-- Disclaimer
-- Dieser Quellcode ist als Vorlage oder als Ideengeber gedacht. Er kann frei und ohne 
-- Auflagen oder Einschrnkungen verwendet oder verndert werden.
-- Jedoch wird keine Garantie bernommen, das eine Funktionsfhigkeit mit aktuellen und 
-- zuknftigen API-Versionen besteht. Der Autor bernimmt daher keine direkte oder indirekte 
-- Verantwortung, wenn dieser Code gar nicht oder nur fehlerhaft ausgefhrt wird.
-- Fr Anregungen und Fragen stehe ich jedoch gerne zur Verfgung.

-- Thorsten Kansy, www.dotnetconsulting.eu

:SETVAR dbname dotnetconsulting.Graph
USE [$(dbname)];
PRINT 'In ''$(dbname)''-Datenbank gewechselt';
GO

-- Exemplarisch eine weitere Person hinzufgen (optional)
DECLARE @form VARCHAR(100) = 'Person#1001';
DECLARE @to VARCHAR(100) = 'Person#2';

INSERT [dbo].[People] ([Name]) VALUES (@form);

-- NodeIds "Von" & "Nach" ermitteln
DECLARE @nodeIdFrom NVARCHAR(1000),
		@nodeIdTo NVARCHAR(1000);

SELECT @nodeIdFrom = $node_id FROM [dbo].[People] WHERE [Name] = @form;
SELECT @nodeIdTo = $node_id FROM [dbo].[People] WHERE [Name] = @to;
INSERT [dbo].[Follows] ($to_id, $from_id) VALUES (@nodeIdFrom, @nodeIdTo);
GO

-- Follows kann nicht von People -> Pets verwendet werden
DECLARE @form VARCHAR(100) = 'Person#1';
DECLARE @to VARCHAR(100) = 'Pet#1';

DECLARE @nodeIdFrom NVARCHAR(1000),
		@nodeIdTo NVARCHAR(1000);

SELECT @nodeIdFrom = $node_id FROM [dbo].[People] WHERE [Name] = @form;
SELECT @nodeIdTo = $node_id FROM [dbo].[Pets] WHERE [Name] = @to;

-- Beziehung einfgen (Fehler!)
INSERT [dbo].[Owns] ($to_id, $from_id)
VALUES (@nodeIdFrom, @nodeIdTo);
